/*! rollup-plugin-json5 v1.0.0 | MIT Licensed | Allex Wang <allex.wxn@gmail.com> */
import JSON5 from 'json5';
import { createFilter, dataToEsm } from 'rollup-pluginutils';

function json() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var filter = createFilter(options.include, options.exclude);
  var indent = 'indent' in options ? options.indent : '\t';
  var test = options.test || function (id) {
    return (/\.(json|babelrc)$/.test(id)
    );
  };

  return {
    name: 'json5',

    transform: function transform(json, id) {
      if (!test(id) || !filter(id)) {
        return null;
      }

      var data = JSON5.parse(json);
      if (Object.prototype.toString.call(data) !== '[object Object]') {
        return { code: 'export default ' + json + ';\n', map: { mappings: '' } };
      }

      return {
        code: dataToEsm(data, { preferConst: options.preferConst, indent: indent }),
        map: { mappings: '' }
      };
    }
  };
}

export default json;
